<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html lang="en">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>LCOV - ombs_test_coverage.info - mongodbhandler/mongodb_handler.cpp</title>
  <link rel="stylesheet" type="text/css" href="../gcov.css">
</head>

<body>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="title">LCOV - code coverage report</td></tr>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>

    <tr>
      <td width="100%">
        <table cellpadding=1 border=0 width="100%">
          <tr>
            <td width="10%" class="headerItem">Current view:</td>
            <td width="35%" class="headerValue"><a href="../index.html">top level</a> - <a href="index.html">mongodbhandler</a> - mongodb_handler.cpp<span style="font-size: 80%;"> (source / <a href="mongodb_handler.cpp.func-sort-c.html">functions</a>)</span></td>
            <td width="5%"></td>
            <td width="15%"></td>
            <td width="10%" class="headerCovTableHead">Hit</td>
            <td width="10%" class="headerCovTableHead">Total</td>
            <td width="15%" class="headerCovTableHead">Coverage</td>
          </tr>
          <tr>
            <td class="headerItem">Test:</td>
            <td class="headerValue">ombs_test_coverage.info</td>
            <td></td>
            <td class="headerItem">Lines:</td>
            <td class="headerCovTableEntry">213</td>
            <td class="headerCovTableEntry">250</td>
            <td class="headerCovTableEntryMed">85.2 %</td>
          </tr>
          <tr>
            <td class="headerItem">Date:</td>
            <td class="headerValue">2022-01-07 08:01:00</td>
            <td></td>
            <td class="headerItem">Functions:</td>
            <td class="headerCovTableEntry">15</td>
            <td class="headerCovTableEntry">15</td>
            <td class="headerCovTableEntryHi">100.0 %</td>
          </tr>
          <tr><td><img src="../glass.png" width=3 height=3 alt=""></td></tr>
        </table>
      </td>
    </tr>

    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
  </table>

  <table cellpadding=0 cellspacing=0 border=0>
    <tr>
      <td><br></td>
    </tr>
    <tr>
      <td>
<pre class="sourceHeading">          Line data    Source code</pre>
<pre class="source">
<a name="1"><span class="lineNum">       1 </span>            : #include &quot;mongodb_handler.hpp&quot;</a>
<a name="2"><span class="lineNum">       2 </span>            : </a>
<a name="3"><span class="lineNum">       3 </span>            : #include &quot;bsoncxx/builder/stream/document.hpp&quot;</a>
<a name="4"><span class="lineNum">       4 </span>            : #include &quot;bsoncxx/json.hpp&quot;</a>
<a name="5"><span class="lineNum">       5 </span>            : #include &quot;log.hpp&quot;</a>
<a name="6"><span class="lineNum">       6 </span>            : </a>
<a name="7"><span class="lineNum">       7 </span>            : namespace omsb</a>
<a name="8"><span class="lineNum">       8 </span>            : {</a>
<a name="9"><span class="lineNum">       9 </span>            :     // Constructor (public)</a>
<a name="10"><span class="lineNum">      10 </span><span class="lineCov">         22 :     MongoDbHandler::MongoDbHandler() : uri(mongocxx::uri(ombsMongoDbUri)),</span></a>
<a name="11"><span class="lineNum">      11 </span><span class="lineCov">         22 :                                        client(mongocxx::client(uri)),</span></a>
<a name="12"><span class="lineNum">      12 </span><span class="lineCov">         22 :                                        db(client[ombsOmbsDatabaseName])</span></a>
<a name="13"><span class="lineNum">      13 </span>            :     {</a>
<a name="14"><span class="lineNum">      14 </span>            :         // TODO data consistence: configure all collections to have unique good id, movies by title, thrater by name, shows by couple of movie and theater ids.</a>
<a name="15"><span class="lineNum">      15 </span><span class="lineCov">         22 :     }</span></a>
<a name="16"><span class="lineNum">      16 </span>            : </a>
<a name="17"><span class="lineNum">      17 </span>            :     // public Methods:</a>
<a name="18"><span class="lineNum">      18 </span><span class="lineCov">          6 :     bool MongoDbHandler::AddMovieToDb(const std::string &amp;movie_title)</span></a>
<a name="19"><span class="lineNum">      19 </span>            :     {</a>
<a name="20"><span class="lineNum">      20 </span><span class="lineCov">          6 :         LOG(&quot;adding a new movie&quot;</span></a>
<a name="21"><span class="lineNum">      21 </span>            :             &lt;&lt; &quot; movie title = &quot; &lt;&lt; movie_title);</a>
<a name="22"><span class="lineNum">      22 </span><span class="lineCov">         12 :         mongocxx::collection collection = db[ombsMoviesCollectionName];</span></a>
<a name="23"><span class="lineNum">      23 </span><span class="lineCov">         12 :         auto builder = bsoncxx::builder::stream::document{};</span></a>
<a name="24"><span class="lineNum">      24 </span>            :         bsoncxx::v_noabi::document::value doc_value =</a>
<a name="25"><span class="lineNum">      25 </span><span class="lineCov">         12 :             builder &lt;&lt; &quot;movieTitle&quot; &lt;&lt; movie_title &lt;&lt; bsoncxx::builder::stream::finalize;</span></a>
<a name="26"><span class="lineNum">      26 </span>            : </a>
<a name="27"><span class="lineNum">      27 </span>            :         try</a>
<a name="28"><span class="lineNum">      28 </span>            :         {</a>
<a name="29"><span class="lineNum">      29 </span>            :             bsoncxx::stdx::optional&lt;mongocxx::result::insert_one&gt; maybe_result =</a>
<a name="30"><span class="lineNum">      30 </span><span class="lineCov">         12 :                 collection.insert_one(doc_value.view());</span></a>
<a name="31"><span class="lineNum">      31 </span><span class="lineCov">          6 :             if (maybe_result)</span></a>
<a name="32"><span class="lineNum">      32 </span>            :             {</a>
<a name="33"><span class="lineNum">      33 </span><span class="lineCov">          6 :                 return maybe_result-&gt;inserted_id().get_oid().value.to_string().size() != 0;</span></a>
<a name="34"><span class="lineNum">      34 </span>            :             }</a>
<a name="35"><span class="lineNum">      35 </span>            :         }</a>
<a name="36"><span class="lineNum">      36 </span><span class="lineNoCov">          0 :         catch (const std::exception &amp;e)</span></a>
<a name="37"><span class="lineNum">      37 </span>            :         {</a>
<a name="38"><span class="lineNum">      38 </span><span class="lineNoCov">          0 :             std::cerr &lt;&lt; &quot;Exception occured&quot; &lt;&lt; std::endl;</span></a>
<a name="39"><span class="lineNum">      39 </span><span class="lineNoCov">          0 :             std::cerr &lt;&lt; e.what() &lt;&lt; std::endl;</span></a>
<a name="40"><span class="lineNum">      40 </span><span class="lineNoCov">          0 :             return false;</span></a>
<a name="41"><span class="lineNum">      41 </span>            :         }</a>
<a name="42"><span class="lineNum">      42 </span><span class="lineNoCov">          0 :         return false;</span></a>
<a name="43"><span class="lineNum">      43 </span>            :     }</a>
<a name="44"><span class="lineNum">      44 </span>            : </a>
<a name="45"><span class="lineNum">      45 </span><span class="lineCov">          7 :     json::JSON MongoDbHandler::GetAllMovies()</span></a>
<a name="46"><span class="lineNum">      46 </span>            :     {</a>
<a name="47"><span class="lineNum">      47 </span><span class="lineCov">         14 :         mongocxx::collection collection = db[ombsMoviesCollectionName];</span></a>
<a name="48"><span class="lineNum">      48 </span><span class="lineCov">         21 :         mongocxx::cursor cursor = collection.find({});</span></a>
<a name="49"><span class="lineNum">      49 </span><span class="lineCov">          7 :         json::JSON result;</span></a>
<a name="50"><span class="lineNum">      50 </span><span class="lineCov">          7 :         result[&quot;movies&quot;] = json::Array();</span></a>
<a name="51"><span class="lineNum">      51 </span><span class="lineCov">          7 :         if (cursor.begin() != cursor.end())</span></a>
<a name="52"><span class="lineNum">      52 </span>            :         {</a>
<a name="53"><span class="lineNum">      53 </span><span class="lineCov">         12 :             for (auto doc : cursor)</span></a>
<a name="54"><span class="lineNum">      54 </span>            :             {</a>
<a name="55"><span class="lineNum">      55 </span><span class="lineCov">          6 :                 result[&quot;movies&quot;].append(json::JSON::Load(bsoncxx::to_json(doc)));</span></a>
<a name="56"><span class="lineNum">      56 </span>            :             }</a>
<a name="57"><span class="lineNum">      57 </span>            :         }</a>
<a name="58"><span class="lineNum">      58 </span><span class="lineCov">         14 :         return result;</span></a>
<a name="59"><span class="lineNum">      59 </span>            :     }</a>
<a name="60"><span class="lineNum">      60 </span>            : </a>
<a name="61"><span class="lineNum">      61 </span><span class="lineCov">          6 :     bool MongoDbHandler::AddTheaterToDb(const std::string &amp;theater_name)</span></a>
<a name="62"><span class="lineNum">      62 </span>            :     {</a>
<a name="63"><span class="lineNum">      63 </span><span class="lineCov">          6 :         LOG(</span></a>
<a name="64"><span class="lineNum">      64 </span>            :             &quot;adding a new theater&quot;</a>
<a name="65"><span class="lineNum">      65 </span>            :             &lt;&lt; &quot; theater Name = &quot; &lt;&lt; theater_name);</a>
<a name="66"><span class="lineNum">      66 </span>            : </a>
<a name="67"><span class="lineNum">      67 </span><span class="lineCov">         12 :         mongocxx::collection collection = db[ombsTheatersCollectionName];</span></a>
<a name="68"><span class="lineNum">      68 </span><span class="lineCov">         12 :         auto builder = bsoncxx::builder::stream::document{};</span></a>
<a name="69"><span class="lineNum">      69 </span>            : </a>
<a name="70"><span class="lineNum">      70 </span>            :         bsoncxx::v_noabi::document::value doc_value =</a>
<a name="71"><span class="lineNum">      71 </span><span class="lineCov">         12 :             builder &lt;&lt; &quot;theaterName&quot; &lt;&lt; theater_name &lt;&lt; bsoncxx::builder::stream::finalize;</span></a>
<a name="72"><span class="lineNum">      72 </span>            : </a>
<a name="73"><span class="lineNum">      73 </span>            :         try</a>
<a name="74"><span class="lineNum">      74 </span>            :         {</a>
<a name="75"><span class="lineNum">      75 </span>            :             bsoncxx::stdx::optional&lt;mongocxx::result::insert_one&gt; maybe_result =</a>
<a name="76"><span class="lineNum">      76 </span><span class="lineCov">         18 :                 collection.insert_one(doc_value.view());</span></a>
<a name="77"><span class="lineNum">      77 </span><span class="lineCov">          6 :             if (maybe_result)</span></a>
<a name="78"><span class="lineNum">      78 </span>            :             {</a>
<a name="79"><span class="lineNum">      79 </span><span class="lineCov">          6 :                 return maybe_result-&gt;inserted_id().get_oid().value.to_string().size() != 0;</span></a>
<a name="80"><span class="lineNum">      80 </span>            :             }</a>
<a name="81"><span class="lineNum">      81 </span>            :             else</a>
<a name="82"><span class="lineNum">      82 </span>            :             {</a>
<a name="83"><span class="lineNum">      83 </span><span class="lineNoCov">          0 :                 return false;</span></a>
<a name="84"><span class="lineNum">      84 </span>            :             }</a>
<a name="85"><span class="lineNum">      85 </span>            :         }</a>
<a name="86"><span class="lineNum">      86 </span><span class="lineNoCov">          0 :         catch (const std::exception &amp;e)</span></a>
<a name="87"><span class="lineNum">      87 </span>            :         {</a>
<a name="88"><span class="lineNum">      88 </span><span class="lineNoCov">          0 :             return false;</span></a>
<a name="89"><span class="lineNum">      89 </span>            :         }</a>
<a name="90"><span class="lineNum">      90 </span>            :     }</a>
<a name="91"><span class="lineNum">      91 </span>            : </a>
<a name="92"><span class="lineNum">      92 </span><span class="lineCov">          7 :     json::JSON MongoDbHandler::GetAllTheaters()</span></a>
<a name="93"><span class="lineNum">      93 </span>            :     {</a>
<a name="94"><span class="lineNum">      94 </span><span class="lineCov">         14 :         mongocxx::collection collection = db[ombsTheatersCollectionName];</span></a>
<a name="95"><span class="lineNum">      95 </span><span class="lineCov">         21 :         mongocxx::cursor cursor = collection.find({});</span></a>
<a name="96"><span class="lineNum">      96 </span><span class="lineCov">          7 :         json::JSON result;</span></a>
<a name="97"><span class="lineNum">      97 </span><span class="lineCov">          7 :         result[&quot;theaters&quot;] = json::Array();</span></a>
<a name="98"><span class="lineNum">      98 </span><span class="lineCov">          7 :         if (cursor.begin() != cursor.end())</span></a>
<a name="99"><span class="lineNum">      99 </span>            :         {</a>
<a name="100"><span class="lineNum">     100 </span><span class="lineCov">         12 :             for (auto doc : cursor)</span></a>
<a name="101"><span class="lineNum">     101 </span>            :             {</a>
<a name="102"><span class="lineNum">     102 </span>            : </a>
<a name="103"><span class="lineNum">     103 </span><span class="lineCov">          6 :                 result[&quot;theaters&quot;].append(json::JSON::Load(bsoncxx::to_json(doc)));</span></a>
<a name="104"><span class="lineNum">     104 </span>            :             }</a>
<a name="105"><span class="lineNum">     105 </span>            :         }</a>
<a name="106"><span class="lineNum">     106 </span><span class="lineCov">         14 :         return result;</span></a>
<a name="107"><span class="lineNum">     107 </span>            :     }</a>
<a name="108"><span class="lineNum">     108 </span>            : </a>
<a name="109"><span class="lineNum">     109 </span><span class="lineCov">          5 :     bool MongoDbHandler::AddMovieShowToDb(const std::string &amp;theater_id, const std::string &amp;movie_id)</span></a>
<a name="110"><span class="lineNum">     110 </span>            :     {</a>
<a name="111"><span class="lineNum">     111 </span><span class="lineCov">          5 :         LOG(</span></a>
<a name="112"><span class="lineNum">     112 </span>            :             &quot; toto adding a new movie show &quot;</a>
<a name="113"><span class="lineNum">     113 </span>            :             &lt;&lt; &quot; theater Id = &quot; &lt;&lt; theater_id</a>
<a name="114"><span class="lineNum">     114 </span>            :             &lt;&lt; &quot; movie Id = &quot; &lt;&lt; movie_id);</a>
<a name="115"><span class="lineNum">     115 </span><span class="lineCov">         10 :         mongocxx::collection collection = db[ombsMovieShowsCollectionName];</span></a>
<a name="116"><span class="lineNum">     116 </span><span class="lineCov">         10 :         auto builder = bsoncxx::builder::stream::document{};</span></a>
<a name="117"><span class="lineNum">     117 </span>            :         try</a>
<a name="118"><span class="lineNum">     118 </span>            :         {</a>
<a name="119"><span class="lineNum">     119 </span><span class="lineCov">          5 :             bsoncxx::oid movie_object_id(movie_id);</span></a>
<a name="120"><span class="lineNum">     120 </span><span class="lineCov">          5 :             builder &lt;&lt; &quot;movieId&quot; &lt;&lt; movie_object_id;</span></a>
<a name="121"><span class="lineNum">     121 </span>            :         }</a>
<a name="122"><span class="lineNum">     122 </span><span class="lineNoCov">          0 :         catch (const std::exception &amp;e)</span></a>
<a name="123"><span class="lineNum">     123 </span>            :         {</a>
<a name="124"><span class="lineNum">     124 </span><span class="lineNoCov">          0 :             LOGERROR(</span></a>
<a name="125"><span class="lineNum">     125 </span>            :                 &quot;this id is not a valide theater Id&quot;</a>
<a name="126"><span class="lineNum">     126 </span>            :                 &lt;&lt; e.what());</a>
<a name="127"><span class="lineNum">     127 </span><span class="lineNoCov">          0 :             return false;</span></a>
<a name="128"><span class="lineNum">     128 </span>            :         }</a>
<a name="129"><span class="lineNum">     129 </span>            : </a>
<a name="130"><span class="lineNum">     130 </span>            :         try</a>
<a name="131"><span class="lineNum">     131 </span>            :         {</a>
<a name="132"><span class="lineNum">     132 </span><span class="lineCov">          5 :             bsoncxx::oid theater_object_id(theater_id);</span></a>
<a name="133"><span class="lineNum">     133 </span><span class="lineCov">          5 :             builder &lt;&lt; &quot;theaterId&quot; &lt;&lt; theater_object_id;</span></a>
<a name="134"><span class="lineNum">     134 </span>            :         }</a>
<a name="135"><span class="lineNum">     135 </span><span class="lineNoCov">          0 :         catch (const std::exception &amp;e)</span></a>
<a name="136"><span class="lineNum">     136 </span>            :         {</a>
<a name="137"><span class="lineNum">     137 </span><span class="lineNoCov">          0 :             LOGERROR(&quot;this id is not a valide theater Id &quot; &lt;&lt; e.what());</span></a>
<a name="138"><span class="lineNum">     138 </span><span class="lineNoCov">          0 :             return false;</span></a>
<a name="139"><span class="lineNum">     139 </span>            :         }</a>
<a name="140"><span class="lineNum">     140 </span>            : </a>
<a name="141"><span class="lineNum">     141 </span><span class="lineCov">          5 :         auto seats_array = builder &lt;&lt; &quot;availableSeatsIds&quot; &lt;&lt; bsoncxx::builder::stream::open_array;</span></a>
<a name="142"><span class="lineNum">     142 </span>            : </a>
<a name="143"><span class="lineNum">     143 </span>            :         // Creating seats for this show</a>
<a name="144"><span class="lineNum">     144 </span><span class="lineCov">         10 :         mongocxx::collection seats_collection = db[ombsSeatsCollectionName];</span></a>
<a name="145"><span class="lineNum">     145 </span>            : </a>
<a name="146"><span class="lineNum">     146 </span><span class="lineCov">        105 :         for (int i = 1; i &lt;= NUMBER_OF_SEATS_FOR_A_MOVIE_IN_THEATER; i++)</span></a>
<a name="147"><span class="lineNum">     147 </span>            :         {</a>
<a name="148"><span class="lineNum">     148 </span><span class="lineCov">        100 :             auto seat_builder = bsoncxx::builder::stream::document{};</span></a>
<a name="149"><span class="lineNum">     149 </span>            :             bsoncxx::v_noabi::document::value seat_doc_value =</a>
<a name="150"><span class="lineNum">     150 </span><span class="lineCov">        100 :                 seat_builder &lt;&lt; &quot;seatName&quot;</span></a>
<a name="151"><span class="lineNum">     151 </span><span class="lineCov">        200 :                              &lt;&lt; &quot;S&quot; + std::to_string(i)</span></a>
<a name="152"><span class="lineNum">     152 </span><span class="lineCov">        100 :                              &lt;&lt; &quot;seatStatus&quot;</span></a>
<a name="153"><span class="lineNum">     153 </span><span class="lineCov">        200 :                              &lt;&lt; &quot;available&quot;</span></a>
<a name="154"><span class="lineNum">     154 </span><span class="lineCov">        100 :                              &lt;&lt; bsoncxx::builder::stream::finalize;</span></a>
<a name="155"><span class="lineNum">     155 </span>            :             try</a>
<a name="156"><span class="lineNum">     156 </span>            :             {</a>
<a name="157"><span class="lineNum">     157 </span>            :                 bsoncxx::stdx::optional&lt;mongocxx::result::insert_one&gt; maybe_result =</a>
<a name="158"><span class="lineNum">     158 </span><span class="lineCov">        200 :                     seats_collection.insert_one(seat_doc_value.view());</span></a>
<a name="159"><span class="lineNum">     159 </span><span class="lineCov">        100 :                 if (maybe_result)</span></a>
<a name="160"><span class="lineNum">     160 </span>            :                 {</a>
<a name="161"><span class="lineNum">     161 </span><span class="lineCov">        100 :                     seats_array = seats_array &lt;&lt; maybe_result-&gt;inserted_id().get_oid().value.to_string();</span></a>
<a name="162"><span class="lineNum">     162 </span>            :                 }</a>
<a name="163"><span class="lineNum">     163 </span>            :                 else</a>
<a name="164"><span class="lineNum">     164 </span>            :                 {</a>
<a name="165"><span class="lineNum">     165 </span><span class="lineNoCov">          0 :                     return false;</span></a>
<a name="166"><span class="lineNum">     166 </span>            :                 }</a>
<a name="167"><span class="lineNum">     167 </span>            :             }</a>
<a name="168"><span class="lineNum">     168 </span><span class="lineNoCov">          0 :             catch (const std::exception &amp;e)</span></a>
<a name="169"><span class="lineNum">     169 </span>            :             {</a>
<a name="170"><span class="lineNum">     170 </span><span class="lineNoCov">          0 :                 return false;</span></a>
<a name="171"><span class="lineNum">     171 </span>            :             }</a>
<a name="172"><span class="lineNum">     172 </span>            :         }</a>
<a name="173"><span class="lineNum">     173 </span><span class="lineCov">          5 :         auto final_seat_array = seats_array &lt;&lt; bsoncxx::builder::stream::close_array;</span></a>
<a name="174"><span class="lineNum">     174 </span>            : </a>
<a name="175"><span class="lineNum">     175 </span>            :         bsoncxx::v_noabi::document::value doc_value =</a>
<a name="176"><span class="lineNum">     176 </span><span class="lineCov">         10 :             final_seat_array &lt;&lt; bsoncxx::builder::stream::finalize;</span></a>
<a name="177"><span class="lineNum">     177 </span>            : </a>
<a name="178"><span class="lineNum">     178 </span><span class="lineCov">          5 :         LOG(</span></a>
<a name="179"><span class="lineNum">     179 </span>            :             &quot; Created seats igs for the show are: &quot;</a>
<a name="180"><span class="lineNum">     180 </span>            :             &lt;&lt; bsoncxx::to_json(doc_value));</a>
<a name="181"><span class="lineNum">     181 </span>            : </a>
<a name="182"><span class="lineNum">     182 </span>            :         try</a>
<a name="183"><span class="lineNum">     183 </span>            :         {</a>
<a name="184"><span class="lineNum">     184 </span>            :             bsoncxx::stdx::optional&lt;mongocxx::result::insert_one&gt; maybe_result =</a>
<a name="185"><span class="lineNum">     185 </span><span class="lineCov">         15 :                 collection.insert_one(doc_value.view());</span></a>
<a name="186"><span class="lineNum">     186 </span><span class="lineCov">          5 :             if (maybe_result)</span></a>
<a name="187"><span class="lineNum">     187 </span>            :             {</a>
<a name="188"><span class="lineNum">     188 </span><span class="lineCov">          5 :                 return maybe_result-&gt;inserted_id().get_oid().value.to_string().size() != 0;</span></a>
<a name="189"><span class="lineNum">     189 </span>            :             }</a>
<a name="190"><span class="lineNum">     190 </span>            :             else</a>
<a name="191"><span class="lineNum">     191 </span>            :             {</a>
<a name="192"><span class="lineNum">     192 </span><span class="lineNoCov">          0 :                 LOGERROR(&quot; Error while trying to insert a movie show&quot;);</span></a>
<a name="193"><span class="lineNum">     193 </span><span class="lineNoCov">          0 :                 return false;</span></a>
<a name="194"><span class="lineNum">     194 </span>            :             }</a>
<a name="195"><span class="lineNum">     195 </span>            :         }</a>
<a name="196"><span class="lineNum">     196 </span><span class="lineNoCov">          0 :         catch (const std::exception &amp;e)</span></a>
<a name="197"><span class="lineNum">     197 </span>            :         {</a>
<a name="198"><span class="lineNum">     198 </span><span class="lineNoCov">          0 :             LOGERROR(e.what());</span></a>
<a name="199"><span class="lineNum">     199 </span><span class="lineNoCov">          0 :             return false;</span></a>
<a name="200"><span class="lineNum">     200 </span>            :         }</a>
<a name="201"><span class="lineNum">     201 </span>            :         return false;</a>
<a name="202"><span class="lineNum">     202 </span>            :     }</a>
<a name="203"><span class="lineNum">     203 </span>            : </a>
<a name="204"><span class="lineNum">     204 </span><span class="lineCov">          7 :     json::JSON MongoDbHandler::GetAllMovieShows()</span></a>
<a name="205"><span class="lineNum">     205 </span>            :     {</a>
<a name="206"><span class="lineNum">     206 </span><span class="lineCov">         14 :         mongocxx::collection shows_collection = db[ombsMovieShowsCollectionName];</span></a>
<a name="207"><span class="lineNum">     207 </span><span class="lineCov">          7 :         json::JSON result;</span></a>
<a name="208"><span class="lineNum">     208 </span><span class="lineCov">         14 :         mongocxx::pipeline pipe{};</span></a>
<a name="209"><span class="lineNum">     209 </span>            : </a>
<a name="210"><span class="lineNum">     210 </span>            :         pipe.match(</a>
<a name="211"><span class="lineNum">     211 </span><span class="lineCov">          7 :             bsoncxx::builder::basic::make_document(</span></a>
<a name="212"><span class="lineNum">     212 </span><span class="lineCov">         14 :                 bsoncxx::builder::basic::kvp(&quot;seats&quot;, bsoncxx::builder::basic::make_document(bsoncxx::builder::basic::kvp(&quot;$ne&quot;, bsoncxx::builder::basic::array{})))));</span></a>
<a name="213"><span class="lineNum">     213 </span>            : </a>
<a name="214"><span class="lineNum">     214 </span>            :         pipe.lookup(</a>
<a name="215"><span class="lineNum">     215 </span><span class="lineCov">          7 :             bsoncxx::builder::basic::make_document(</span></a>
<a name="216"><span class="lineNum">     216 </span><span class="lineCov">          7 :                 bsoncxx::builder::basic::kvp(&quot;from&quot;, ombsMoviesCollectionName),</span></a>
<a name="217"><span class="lineNum">     217 </span><span class="lineCov">          7 :                 bsoncxx::builder::basic::kvp(&quot;localField&quot;, &quot;movieId&quot;),</span></a>
<a name="218"><span class="lineNum">     218 </span><span class="lineCov">          7 :                 bsoncxx::builder::basic::kvp(&quot;foreignField&quot;, &quot;_id&quot;),</span></a>
<a name="219"><span class="lineNum">     219 </span><span class="lineCov">         14 :                 bsoncxx::builder::basic::kvp(&quot;as&quot;, &quot;movie&quot;)));</span></a>
<a name="220"><span class="lineNum">     220 </span>            : </a>
<a name="221"><span class="lineNum">     221 </span>            :         pipe.project(</a>
<a name="222"><span class="lineNum">     222 </span><span class="lineCov">          7 :             bsoncxx::builder::basic::make_document(</span></a>
<a name="223"><span class="lineNum">     223 </span><span class="lineCov">          7 :                 bsoncxx::builder::basic::kvp(&quot;movie.movieTitle&quot;, 1),</span></a>
<a name="224"><span class="lineNum">     224 </span><span class="lineCov">          7 :                 bsoncxx::builder::basic::kvp(&quot;movie._id&quot;, 1),</span></a>
<a name="225"><span class="lineNum">     225 </span><span class="lineCov">         14 :                 bsoncxx::builder::basic::kvp(&quot;_id&quot;, 0)));</span></a>
<a name="226"><span class="lineNum">     226 </span>            : </a>
<a name="227"><span class="lineNum">     227 </span><span class="lineCov">          7 :         pipe.unwind(&quot;$movie&quot;);</span></a>
<a name="228"><span class="lineNum">     228 </span>            : </a>
<a name="229"><span class="lineNum">     229 </span>            :         pipe.group(</a>
<a name="230"><span class="lineNum">     230 </span><span class="lineCov">          7 :             bsoncxx::builder::basic::make_document(</span></a>
<a name="231"><span class="lineNum">     231 </span><span class="lineCov">          7 :                 bsoncxx::builder::basic::kvp(&quot;_id&quot;, &quot;movie&quot;),</span></a>
<a name="232"><span class="lineNum">     232 </span><span class="lineCov">         14 :                 bsoncxx::builder::basic::kvp(&quot;shows&quot;, bsoncxx::builder::basic::make_document(</span></a>
<a name="233"><span class="lineNum">     233 </span><span class="lineCov">         14 :                                                           bsoncxx::builder::basic::kvp(&quot;$addToSet&quot;, &quot;$movie&quot;)))));</span></a>
<a name="234"><span class="lineNum">     234 </span>            : </a>
<a name="235"><span class="lineNum">     235 </span>            :         pipe.project(</a>
<a name="236"><span class="lineNum">     236 </span><span class="lineCov">          7 :             bsoncxx::builder::basic::make_document(</span></a>
<a name="237"><span class="lineNum">     237 </span><span class="lineCov">          7 :                 bsoncxx::builder::basic::kvp(&quot;shows&quot;, 1),</span></a>
<a name="238"><span class="lineNum">     238 </span><span class="lineCov">         14 :                 bsoncxx::builder::basic::kvp(&quot;_id&quot;, 0)));</span></a>
<a name="239"><span class="lineNum">     239 </span>            : </a>
<a name="240"><span class="lineNum">     240 </span><span class="lineCov">         14 :         auto cursor = shows_collection.aggregate(pipe, mongocxx::options::aggregate{});</span></a>
<a name="241"><span class="lineNum">     241 </span>            : </a>
<a name="242"><span class="lineNum">     242 </span><span class="lineCov">          7 :         result = json::Object();</span></a>
<a name="243"><span class="lineNum">     243 </span>            : </a>
<a name="244"><span class="lineNum">     244 </span><span class="lineCov">          7 :         if (cursor.begin() != cursor.end())</span></a>
<a name="245"><span class="lineNum">     245 </span>            :         {</a>
<a name="246"><span class="lineNum">     246 </span><span class="lineCov">          6 :             for (auto doc : cursor)</span></a>
<a name="247"><span class="lineNum">     247 </span>            :             {</a>
<a name="248"><span class="lineNum">     248 </span><span class="lineCov">          3 :                 result = json::JSON::Load(bsoncxx::to_json(doc));</span></a>
<a name="249"><span class="lineNum">     249 </span>            :             }</a>
<a name="250"><span class="lineNum">     250 </span>            :         }</a>
<a name="251"><span class="lineNum">     251 </span><span class="lineCov">         14 :         return result;</span></a>
<a name="252"><span class="lineNum">     252 </span>            :     }</a>
<a name="253"><span class="lineNum">     253 </span>            : </a>
<a name="254"><span class="lineNum">     254 </span><span class="lineCov">          2 :     json::JSON MongoDbHandler::GetTheatersByMovie(const std::string &amp;movie_id)</span></a>
<a name="255"><span class="lineNum">     255 </span>            :     {</a>
<a name="256"><span class="lineNum">     256 </span>            : </a>
<a name="257"><span class="lineNum">     257 </span><span class="lineCov">          2 :         LOG(</span></a>
<a name="258"><span class="lineNum">     258 </span>            :             &quot;Database handler: looking for theaters with available seats showing movie_id : &quot;</a>
<a name="259"><span class="lineNum">     259 </span>            :             &lt;&lt; movie_id);</a>
<a name="260"><span class="lineNum">     260 </span><span class="lineCov">          4 :         mongocxx::collection shows_collection = db[ombsMovieShowsCollectionName];</span></a>
<a name="261"><span class="lineNum">     261 </span><span class="lineCov">          2 :         json::JSON result;</span></a>
<a name="262"><span class="lineNum">     262 </span><span class="lineCov">          4 :         mongocxx::pipeline pipe{};</span></a>
<a name="263"><span class="lineNum">     263 </span><span class="lineCov">          2 :         bsoncxx::oid movie_object_id(movie_id);</span></a>
<a name="264"><span class="lineNum">     264 </span>            :         pipe.match(</a>
<a name="265"><span class="lineNum">     265 </span><span class="lineCov">          2 :             bsoncxx::builder::basic::make_document(</span></a>
<a name="266"><span class="lineNum">     266 </span><span class="lineCov">          2 :                 bsoncxx::builder::basic::kvp(&quot;movieId&quot;, movie_object_id),</span></a>
<a name="267"><span class="lineNum">     267 </span><span class="lineCov">          4 :                 bsoncxx::builder::basic::kvp(&quot;seats&quot;, bsoncxx::builder::basic::make_document(bsoncxx::builder::basic::kvp(&quot;$ne&quot;, bsoncxx::builder::basic::array{})))));</span></a>
<a name="268"><span class="lineNum">     268 </span>            : </a>
<a name="269"><span class="lineNum">     269 </span>            :         pipe.lookup(</a>
<a name="270"><span class="lineNum">     270 </span><span class="lineCov">          2 :             bsoncxx::builder::basic::make_document(</span></a>
<a name="271"><span class="lineNum">     271 </span><span class="lineCov">          2 :                 bsoncxx::builder::basic::kvp(&quot;from&quot;, ombsTheatersCollectionName),</span></a>
<a name="272"><span class="lineNum">     272 </span><span class="lineCov">          2 :                 bsoncxx::builder::basic::kvp(&quot;localField&quot;, &quot;theaterId&quot;),</span></a>
<a name="273"><span class="lineNum">     273 </span><span class="lineCov">          2 :                 bsoncxx::builder::basic::kvp(&quot;foreignField&quot;, &quot;_id&quot;),</span></a>
<a name="274"><span class="lineNum">     274 </span><span class="lineCov">          4 :                 bsoncxx::builder::basic::kvp(&quot;as&quot;, &quot;theater&quot;)));</span></a>
<a name="275"><span class="lineNum">     275 </span>            : </a>
<a name="276"><span class="lineNum">     276 </span>            :         pipe.project(</a>
<a name="277"><span class="lineNum">     277 </span><span class="lineCov">          2 :             bsoncxx::builder::basic::make_document(</span></a>
<a name="278"><span class="lineNum">     278 </span><span class="lineCov">          2 :                 bsoncxx::builder::basic::kvp(&quot;theater.theaterName&quot;, 1),</span></a>
<a name="279"><span class="lineNum">     279 </span><span class="lineCov">          2 :                 bsoncxx::builder::basic::kvp(&quot;theater._id&quot;, 1),</span></a>
<a name="280"><span class="lineNum">     280 </span><span class="lineCov">          4 :                 bsoncxx::builder::basic::kvp(&quot;_id&quot;, 0)));</span></a>
<a name="281"><span class="lineNum">     281 </span>            : </a>
<a name="282"><span class="lineNum">     282 </span><span class="lineCov">          2 :         pipe.unwind(&quot;$theater&quot;);</span></a>
<a name="283"><span class="lineNum">     283 </span>            : </a>
<a name="284"><span class="lineNum">     284 </span>            :         pipe.project(</a>
<a name="285"><span class="lineNum">     285 </span><span class="lineCov">          2 :             bsoncxx::builder::basic::make_document(</span></a>
<a name="286"><span class="lineNum">     286 </span><span class="lineCov">          2 :                 bsoncxx::builder::basic::kvp(&quot;theater._id&quot;, 1),</span></a>
<a name="287"><span class="lineNum">     287 </span><span class="lineCov">          4 :                 bsoncxx::builder::basic::kvp(&quot;theater.theaterName&quot;, 1)));</span></a>
<a name="288"><span class="lineNum">     288 </span>            : </a>
<a name="289"><span class="lineNum">     289 </span><span class="lineCov">          4 :         auto cursor = shows_collection.aggregate(pipe, mongocxx::options::aggregate{});</span></a>
<a name="290"><span class="lineNum">     290 </span>            : </a>
<a name="291"><span class="lineNum">     291 </span><span class="lineCov">          2 :         result = json::Array();</span></a>
<a name="292"><span class="lineNum">     292 </span>            : </a>
<a name="293"><span class="lineNum">     293 </span><span class="lineCov">          2 :         if (cursor.begin() != cursor.end())</span></a>
<a name="294"><span class="lineNum">     294 </span>            :         {</a>
<a name="295"><span class="lineNum">     295 </span><span class="lineCov">          4 :             for (auto doc : cursor)</span></a>
<a name="296"><span class="lineNum">     296 </span>            :             {</a>
<a name="297"><span class="lineNum">     297 </span><span class="lineCov">          2 :                 result.append(json::JSON::Load(bsoncxx::to_json(doc)));</span></a>
<a name="298"><span class="lineNum">     298 </span>            :             }</a>
<a name="299"><span class="lineNum">     299 </span>            :         }</a>
<a name="300"><span class="lineNum">     300 </span><span class="lineCov">          4 :         return result;</span></a>
<a name="301"><span class="lineNum">     301 </span>            :     }</a>
<a name="302"><span class="lineNum">     302 </span>            : </a>
<a name="303"><span class="lineNum">     303 </span><span class="lineCov">          3 :     json::JSON MongoDbHandler::GetSeatsByMovieAndByTheater(const std::string &amp;movie_id, const std::string &amp;theater_id)</span></a>
<a name="304"><span class="lineNum">     304 </span>            :     {</a>
<a name="305"><span class="lineNum">     305 </span>            : </a>
<a name="306"><span class="lineNum">     306 </span><span class="lineCov">          3 :         LOG(</span></a>
<a name="307"><span class="lineNum">     307 </span>            :             &quot; Database handler: looking for available seats for movie_id : &quot;</a>
<a name="308"><span class="lineNum">     308 </span>            :             &lt;&lt; movie_id &lt;&lt; &quot;and theaer_id : &quot; &lt;&lt; theater_id);</a>
<a name="309"><span class="lineNum">     309 </span>            : </a>
<a name="310"><span class="lineNum">     310 </span><span class="lineCov">          6 :         mongocxx::collection shows_collection = db[ombsMovieShowsCollectionName];</span></a>
<a name="311"><span class="lineNum">     311 </span><span class="lineCov">          3 :         json::JSON result;</span></a>
<a name="312"><span class="lineNum">     312 </span><span class="lineCov">          6 :         mongocxx::pipeline pipe{};</span></a>
<a name="313"><span class="lineNum">     313 </span>            : </a>
<a name="314"><span class="lineNum">     314 </span>            :         // TODO Mandatory : for robustness add try catch</a>
<a name="315"><span class="lineNum">     315 </span><span class="lineCov">          3 :         bsoncxx::oid movie_object_id(movie_id);</span></a>
<a name="316"><span class="lineNum">     316 </span><span class="lineCov">          3 :         bsoncxx::oid theater_object_id(theater_id);</span></a>
<a name="317"><span class="lineNum">     317 </span>            : </a>
<a name="318"><span class="lineNum">     318 </span>            :         pipe.match(</a>
<a name="319"><span class="lineNum">     319 </span><span class="lineCov">          3 :             bsoncxx::builder::basic::make_document(</span></a>
<a name="320"><span class="lineNum">     320 </span><span class="lineCov">          3 :                 bsoncxx::builder::basic::kvp(&quot;movieId&quot;, movie_object_id),</span></a>
<a name="321"><span class="lineNum">     321 </span><span class="lineCov">          3 :                 bsoncxx::builder::basic::kvp(&quot;theaterId&quot;, theater_object_id),</span></a>
<a name="322"><span class="lineNum">     322 </span><span class="lineCov">          6 :                 bsoncxx::builder::basic::kvp(&quot;availableSeatsIds&quot;, bsoncxx::builder::basic::make_document(bsoncxx::builder::basic::kvp(&quot;$ne&quot;, bsoncxx::builder::basic::array{})))));</span></a>
<a name="323"><span class="lineNum">     323 </span>            : </a>
<a name="324"><span class="lineNum">     324 </span>            :         pipe.project(</a>
<a name="325"><span class="lineNum">     325 </span><span class="lineCov">          3 :             bsoncxx::builder::basic::make_document(</span></a>
<a name="326"><span class="lineNum">     326 </span><span class="lineCov">          3 :                 bsoncxx::builder::basic::kvp(&quot;availableSeatsIds&quot;, 1),</span></a>
<a name="327"><span class="lineNum">     327 </span><span class="lineCov">          6 :                 bsoncxx::builder::basic::kvp(&quot;_id&quot;, 0)));</span></a>
<a name="328"><span class="lineNum">     328 </span>            : </a>
<a name="329"><span class="lineNum">     329 </span><span class="lineCov">          6 :         auto cursor = shows_collection.aggregate(pipe, mongocxx::options::aggregate{});</span></a>
<a name="330"><span class="lineNum">     330 </span>            : </a>
<a name="331"><span class="lineNum">     331 </span><span class="lineCov">          3 :         result = json::Object();</span></a>
<a name="332"><span class="lineNum">     332 </span>            : </a>
<a name="333"><span class="lineNum">     333 </span><span class="lineCov">          3 :         if (cursor.begin() != cursor.end())</span></a>
<a name="334"><span class="lineNum">     334 </span>            :         {</a>
<a name="335"><span class="lineNum">     335 </span><span class="lineCov">          6 :             for (auto doc : cursor)</span></a>
<a name="336"><span class="lineNum">     336 </span>            :             {</a>
<a name="337"><span class="lineNum">     337 </span><span class="lineCov">          3 :                 result = json::JSON::Load(bsoncxx::to_json(doc));</span></a>
<a name="338"><span class="lineNum">     338 </span>            :             }</a>
<a name="339"><span class="lineNum">     339 </span>            :         }</a>
<a name="340"><span class="lineNum">     340 </span><span class="lineCov">          6 :         return result;</span></a>
<a name="341"><span class="lineNum">     341 </span>            :     }</a>
<a name="342"><span class="lineNum">     342 </span>            : </a>
<a name="343"><span class="lineNum">     343 </span><span class="lineCov">          4 :     bool MongoDbHandler::BookSeats(const std::vector&lt;std::string&gt; &amp;seatsIdsList)</span></a>
<a name="344"><span class="lineNum">     344 </span>            :     {</a>
<a name="345"><span class="lineNum">     345 </span>            :         // Check that we have at least one seat to book</a>
<a name="346"><span class="lineNum">     346 </span><span class="lineCov">          4 :         if (seatsIdsList.size() &lt;= 0)</span></a>
<a name="347"><span class="lineNum">     347 </span>            :         {</a>
<a name="348"><span class="lineNum">     348 </span><span class="lineNoCov">          0 :             return false;</span></a>
<a name="349"><span class="lineNum">     349 </span>            :         }</a>
<a name="350"><span class="lineNum">     350 </span>            : </a>
<a name="351"><span class="lineNum">     351 </span><span class="lineCov">          8 :         std::string first_seat_id = seatsIdsList[0];</span></a>
<a name="352"><span class="lineNum">     352 </span><span class="lineCov">          8 :         std::string show_id = FindShowIdBySeat(first_seat_id);</span></a>
<a name="353"><span class="lineNum">     353 </span>            : </a>
<a name="354"><span class="lineNum">     354 </span>            :         // Looking for coresponding show_id for tfirst seat_id</a>
<a name="355"><span class="lineNum">     355 </span><span class="lineCov">          4 :         if (!show_id.size())</span></a>
<a name="356"><span class="lineNum">     356 </span>            :         {</a>
<a name="357"><span class="lineNum">     357 </span><span class="lineCov">          2 :             return false;</span></a>
<a name="358"><span class="lineNum">     358 </span>            :         }</a>
<a name="359"><span class="lineNum">     359 </span>            : </a>
<a name="360"><span class="lineNum">     360 </span>            :         // Check that precondition of all seats_ids belongs to the show_id of the first seat_id and no over booking for same seat</a>
<a name="361"><span class="lineNum">     361 </span><span class="lineCov">         13 :         for (const auto &amp;seat_id : seatsIdsList)</span></a>
<a name="362"><span class="lineNum">     362 </span>            :         {</a>
<a name="363"><span class="lineNum">     363 </span><span class="lineCov">         11 :             if (FindShowIdBySeat(seat_id) != show_id)</span></a>
<a name="364"><span class="lineNum">     364 </span>            :             {</a>
<a name="365"><span class="lineNum">     365 </span><span class="lineNoCov">          0 :                 std::cerr &lt;&lt; &quot;seat_id : &quot; &lt;&lt; seat_id &lt;&lt; &quot; not found in the show&quot; &lt;&lt; std::endl;</span></a>
<a name="366"><span class="lineNum">     366 </span><span class="lineNoCov">          0 :                 return false;</span></a>
<a name="367"><span class="lineNum">     367 </span>            :             }</a>
<a name="368"><span class="lineNum">     368 </span>            : </a>
<a name="369"><span class="lineNum">     369 </span><span class="lineCov">         11 :             if (count(seatsIdsList.begin(), seatsIdsList.end(), seat_id) != 1)</span></a>
<a name="370"><span class="lineNum">     370 </span>            :             {</a>
<a name="371"><span class="lineNum">     371 </span><span class="lineNoCov">          0 :                 std::cerr &lt;&lt; &quot;can not book seat_id : &quot; &lt;&lt; seat_id &lt;&lt; &quot; more than one time&quot; &lt;&lt; std::endl;</span></a>
<a name="372"><span class="lineNum">     372 </span><span class="lineNoCov">          0 :                 return false;</span></a>
<a name="373"><span class="lineNum">     373 </span>            :             }</a>
<a name="374"><span class="lineNum">     374 </span>            :         }</a>
<a name="375"><span class="lineNum">     375 </span>            : </a>
<a name="376"><span class="lineNum">     376 </span><span class="lineCov">          4 :         std::vector&lt;std::string&gt; successful_booked_seats_ids_list{};</span></a>
<a name="377"><span class="lineNum">     377 </span><span class="lineCov">          2 :         bool all_seats_booked = true;</span></a>
<a name="378"><span class="lineNum">     378 </span>            : </a>
<a name="379"><span class="lineNum">     379 </span>            :         // Creating a booking</a>
<a name="380"><span class="lineNum">     380 </span><span class="lineCov">          4 :         std::string booking_id = CreateBooking(show_id);</span></a>
<a name="381"><span class="lineNum">     381 </span><span class="lineCov">          2 :         LOG(</span></a>
<a name="382"><span class="lineNum">     382 </span>            :             &quot;Booking Created booking_id = &quot;</a>
<a name="383"><span class="lineNum">     383 </span>            :             &lt;&lt; booking_id);</a>
<a name="384"><span class="lineNum">     384 </span>            : </a>
<a name="385"><span class="lineNum">     385 </span>            :         // Booking seat, this is critical section acquire lock</a>
<a name="386"><span class="lineNum">     386 </span><span class="lineCov">          2 :         seats_booking_mutex_lock.lock();</span></a>
<a name="387"><span class="lineNum">     387 </span><span class="lineCov">         13 :         for (const auto &amp;seat_id : seatsIdsList)</span></a>
<a name="388"><span class="lineNum">     388 </span>            :         {</a>
<a name="389"><span class="lineNum">     389 </span><span class="lineCov">         11 :             if (BookSingleSeat(seat_id, show_id, booking_id))</span></a>
<a name="390"><span class="lineNum">     390 </span>            :             {</a>
<a name="391"><span class="lineNum">     391 </span><span class="lineCov">         11 :                 successful_booked_seats_ids_list.emplace_back(seat_id);</span></a>
<a name="392"><span class="lineNum">     392 </span>            :             }</a>
<a name="393"><span class="lineNum">     393 </span>            :             else</a>
<a name="394"><span class="lineNum">     394 </span>            :             {</a>
<a name="395"><span class="lineNum">     395 </span><span class="lineNoCov">          0 :                 all_seats_booked = false;</span></a>
<a name="396"><span class="lineNum">     396 </span><span class="lineNoCov">          0 :                 break;</span></a>
<a name="397"><span class="lineNum">     397 </span>            :             }</a>
<a name="398"><span class="lineNum">     398 </span>            :         }</a>
<a name="399"><span class="lineNum">     399 </span>            :         // Release lock</a>
<a name="400"><span class="lineNum">     400 </span><span class="lineCov">          2 :         seats_booking_mutex_lock.unlock();</span></a>
<a name="401"><span class="lineNum">     401 </span>            : </a>
<a name="402"><span class="lineNum">     402 </span><span class="lineCov">          2 :         LOG(</span></a>
<a name="403"><span class="lineNum">     403 </span>            :             &quot;number of successfuly booked seats = &quot;</a>
<a name="404"><span class="lineNum">     404 </span>            :             &lt;&lt; std::to_string(successful_booked_seats_ids_list.size()));</a>
<a name="405"><span class="lineNum">     405 </span>            : </a>
<a name="406"><span class="lineNum">     406 </span><span class="lineCov">          2 :         return all_seats_booked;</span></a>
<a name="407"><span class="lineNum">     407 </span>            :     }</a>
<a name="408"><span class="lineNum">     408 </span>            : </a>
<a name="409"><span class="lineNum">     409 </span><span class="lineCov">          6 :     bool MongoDbHandler::DropDatabase()</span></a>
<a name="410"><span class="lineNum">     410 </span>            :     {</a>
<a name="411"><span class="lineNum">     411 </span><span class="lineCov">          6 :         db.drop();</span></a>
<a name="412"><span class="lineNum">     412 </span><span class="lineCov">          6 :         return true;</span></a>
<a name="413"><span class="lineNum">     413 </span>            :     }</a>
<a name="414"><span class="lineNum">     414 </span>            : </a>
<a name="415"><span class="lineNum">     415 </span>            :     // private methods</a>
<a name="416"><span class="lineNum">     416 </span><span class="lineCov">         11 :     bool MongoDbHandler::BookSingleSeat(const std::string &amp;seat_id, std::string &amp;show_id, const std::string &amp;booking_id)</span></a>
<a name="417"><span class="lineNum">     417 </span>            :     {</a>
<a name="418"><span class="lineNum">     418 </span>            : </a>
<a name="419"><span class="lineNum">     419 </span><span class="lineCov">         22 :         mongocxx::collection collection = db[ombsMovieShowsCollectionName];</span></a>
<a name="420"><span class="lineNum">     420 </span>            : </a>
<a name="421"><span class="lineNum">     421 </span><span class="lineCov">         22 :         auto builder = bsoncxx::builder::stream::document{};</span></a>
<a name="422"><span class="lineNum">     422 </span><span class="lineCov">         11 :         bsoncxx::oid show_object_id(show_id);</span></a>
<a name="423"><span class="lineNum">     423 </span>            :         bsoncxx::document::value query_doc =</a>
<a name="424"><span class="lineNum">     424 </span><span class="lineCov">         11 :             builder &lt;&lt; &quot;_id&quot; &lt;&lt; show_object_id</span></a>
<a name="425"><span class="lineNum">     425 </span><span class="lineCov">         22 :                     &lt;&lt; bsoncxx::builder::stream::finalize;</span></a>
<a name="426"><span class="lineNum">     426 </span>            : </a>
<a name="427"><span class="lineNum">     427 </span>            :         bsoncxx::document::value remove_doc =</a>
<a name="428"><span class="lineNum">     428 </span><span class="lineCov">         11 :             builder &lt;&lt; &quot;$pull&quot; &lt;&lt; bsoncxx::builder::stream::open_document &lt;&lt; &quot;availableSeatsIds&quot;</span></a>
<a name="429"><span class="lineNum">     429 </span><span class="lineCov">         11 :                     &lt;&lt; seat_id &lt;&lt; bsoncxx::builder::stream::close_document</span></a>
<a name="430"><span class="lineNum">     430 </span><span class="lineCov">         22 :                     &lt;&lt; bsoncxx::builder::stream::finalize;</span></a>
<a name="431"><span class="lineNum">     431 </span>            : </a>
<a name="432"><span class="lineNum">     432 </span>            :         bsoncxx::stdx::optional&lt;mongocxx::result::update&gt; maybe_result =</a>
<a name="433"><span class="lineNum">     433 </span><span class="lineCov">         33 :             collection.update_one(query_doc.view(), remove_doc.view());</span></a>
<a name="434"><span class="lineNum">     434 </span>            : </a>
<a name="435"><span class="lineNum">     435 </span><span class="lineCov">         11 :         if (maybe_result &amp;&amp; maybe_result-&gt;modified_count() == 1)</span></a>
<a name="436"><span class="lineNum">     436 </span>            :         {</a>
<a name="437"><span class="lineNum">     437 </span>            :             // inserting booked seat to the booking</a>
<a name="438"><span class="lineNum">     438 </span><span class="lineCov">         11 :             InsertSeatToBooking(seat_id, booking_id);</span></a>
<a name="439"><span class="lineNum">     439 </span><span class="lineCov">         11 :             return true;</span></a>
<a name="440"><span class="lineNum">     440 </span>            :         }</a>
<a name="441"><span class="lineNum">     441 </span>            :         else</a>
<a name="442"><span class="lineNum">     442 </span>            :         {</a>
<a name="443"><span class="lineNum">     443 </span><span class="lineNoCov">          0 :             return false;</span></a>
<a name="444"><span class="lineNum">     444 </span>            :         }</a>
<a name="445"><span class="lineNum">     445 </span>            :     }</a>
<a name="446"><span class="lineNum">     446 </span>            : </a>
<a name="447"><span class="lineNum">     447 </span><span class="lineCov">         15 :     std::string MongoDbHandler::FindShowIdBySeat(const std::string &amp;seat_id)</span></a>
<a name="448"><span class="lineNum">     448 </span>            :     {</a>
<a name="449"><span class="lineNum">     449 </span><span class="lineCov">         30 :         mongocxx::collection collection = db[ombsMovieShowsCollectionName];</span></a>
<a name="450"><span class="lineNum">     450 </span><span class="lineCov">         30 :         auto builder = bsoncxx::builder::stream::document{};</span></a>
<a name="451"><span class="lineNum">     451 </span>            :         bsoncxx::document::value query_doc =</a>
<a name="452"><span class="lineNum">     452 </span><span class="lineCov">         15 :             builder &lt;&lt; &quot;availableSeatsIds&quot; &lt;&lt; seat_id</span></a>
<a name="453"><span class="lineNum">     453 </span><span class="lineCov">         30 :                     &lt;&lt; bsoncxx::builder::stream::finalize;</span></a>
<a name="454"><span class="lineNum">     454 </span>            : </a>
<a name="455"><span class="lineNum">     455 </span><span class="lineCov">         45 :         mongocxx::cursor cursor = collection.find(query_doc.view());</span></a>
<a name="456"><span class="lineNum">     456 </span>            : </a>
<a name="457"><span class="lineNum">     457 </span><span class="lineCov">         30 :         json::JSON result = json::Array();</span></a>
<a name="458"><span class="lineNum">     458 </span><span class="lineCov">         15 :         if (cursor.begin() != cursor.end())</span></a>
<a name="459"><span class="lineNum">     459 </span>            :         {</a>
<a name="460"><span class="lineNum">     460 </span><span class="lineCov">         26 :             for (auto doc : cursor)</span></a>
<a name="461"><span class="lineNum">     461 </span>            :             {</a>
<a name="462"><span class="lineNum">     462 </span><span class="lineCov">         13 :                 result.append(json::JSON::Load(bsoncxx::to_json(doc)));</span></a>
<a name="463"><span class="lineNum">     463 </span>            :             }</a>
<a name="464"><span class="lineNum">     464 </span>            :             // extracting showId</a>
<a name="465"><span class="lineNum">     465 </span><span class="lineCov">         26 :             const std::string show_id_key = &quot;_id&quot;;</span></a>
<a name="466"><span class="lineNum">     466 </span><span class="lineCov">         26 :             const std::string show_oid_key = &quot;$oid&quot;;</span></a>
<a name="467"><span class="lineNum">     467 </span><span class="lineCov">         13 :             if (result.at(0).hasKey(show_id_key))</span></a>
<a name="468"><span class="lineNum">     468 </span>            :             {</a>
<a name="469"><span class="lineNum">     469 </span><span class="lineCov">         13 :                 return result.at(0).at(show_id_key).at(show_oid_key).ToString();</span></a>
<a name="470"><span class="lineNum">     470 </span>            :             }</a>
<a name="471"><span class="lineNum">     471 </span>            :             else</a>
<a name="472"><span class="lineNum">     472 </span>            :             {</a>
<a name="473"><span class="lineNum">     473 </span><span class="lineNoCov">          0 :                 return &quot;&quot;;</span></a>
<a name="474"><span class="lineNum">     474 </span>            :             }</a>
<a name="475"><span class="lineNum">     475 </span>            :         }</a>
<a name="476"><span class="lineNum">     476 </span>            :         else</a>
<a name="477"><span class="lineNum">     477 </span>            :         {</a>
<a name="478"><span class="lineNum">     478 </span><span class="lineCov">          2 :             return &quot;&quot;;</span></a>
<a name="479"><span class="lineNum">     479 </span>            :         }</a>
<a name="480"><span class="lineNum">     480 </span>            :     }</a>
<a name="481"><span class="lineNum">     481 </span>            : </a>
<a name="482"><span class="lineNum">     482 </span><span class="lineCov">         11 :     bool MongoDbHandler::InsertSeatToBooking(const std::string &amp;seat_id, const std::string &amp;book_id)</span></a>
<a name="483"><span class="lineNum">     483 </span>            :     {</a>
<a name="484"><span class="lineNum">     484 </span><span class="lineCov">         22 :         mongocxx::collection collection = db[ombsBookingsCollectionName];</span></a>
<a name="485"><span class="lineNum">     485 </span><span class="lineCov">         22 :         auto builder = bsoncxx::builder::stream::document{};</span></a>
<a name="486"><span class="lineNum">     486 </span><span class="lineCov">         11 :         bsoncxx::oid document_id(book_id);</span></a>
<a name="487"><span class="lineNum">     487 </span>            : </a>
<a name="488"><span class="lineNum">     488 </span>            :         bsoncxx::document::value query_doc =</a>
<a name="489"><span class="lineNum">     489 </span><span class="lineCov">         11 :             builder &lt;&lt; &quot;_id&quot; &lt;&lt; document_id</span></a>
<a name="490"><span class="lineNum">     490 </span><span class="lineCov">         22 :                     &lt;&lt; bsoncxx::builder::stream::finalize;</span></a>
<a name="491"><span class="lineNum">     491 </span>            :         bsoncxx::document::value update_doc =</a>
<a name="492"><span class="lineNum">     492 </span><span class="lineCov">         11 :             builder &lt;&lt; &quot;$addToSet&quot; &lt;&lt; bsoncxx::builder::stream::open_document &lt;&lt; &quot;bookedSeatsIds&quot;</span></a>
<a name="493"><span class="lineNum">     493 </span><span class="lineCov">         11 :                     &lt;&lt; seat_id &lt;&lt; bsoncxx::builder::stream::close_document</span></a>
<a name="494"><span class="lineNum">     494 </span><span class="lineCov">         22 :                     &lt;&lt; bsoncxx::builder::stream::finalize;</span></a>
<a name="495"><span class="lineNum">     495 </span>            : </a>
<a name="496"><span class="lineNum">     496 </span>            :         bsoncxx::stdx::optional&lt;mongocxx::result::update&gt; maybe_result =</a>
<a name="497"><span class="lineNum">     497 </span><span class="lineCov">         33 :             collection.update_one(query_doc.view(), update_doc.view());</span></a>
<a name="498"><span class="lineNum">     498 </span>            : </a>
<a name="499"><span class="lineNum">     499 </span><span class="lineCov">         11 :         if (maybe_result)</span></a>
<a name="500"><span class="lineNum">     500 </span>            :         {</a>
<a name="501"><span class="lineNum">     501 </span><span class="lineCov">         11 :             return maybe_result-&gt;modified_count() == 1;</span></a>
<a name="502"><span class="lineNum">     502 </span>            :         }</a>
<a name="503"><span class="lineNum">     503 </span><span class="lineNoCov">          0 :         return false;</span></a>
<a name="504"><span class="lineNum">     504 </span>            :     }</a>
<a name="505"><span class="lineNum">     505 </span>            : </a>
<a name="506"><span class="lineNum">     506 </span><span class="lineCov">          2 :     std::string MongoDbHandler::CreateBooking(const std::string &amp;show_id, const std::string &amp;user_email)</span></a>
<a name="507"><span class="lineNum">     507 </span>            :     {</a>
<a name="508"><span class="lineNum">     508 </span>            : </a>
<a name="509"><span class="lineNum">     509 </span><span class="lineCov">          4 :         mongocxx::collection collection = db[ombsBookingsCollectionName];</span></a>
<a name="510"><span class="lineNum">     510 </span>            : </a>
<a name="511"><span class="lineNum">     511 </span><span class="lineCov">          4 :         auto builder = bsoncxx::builder::stream::document{};</span></a>
<a name="512"><span class="lineNum">     512 </span>            : </a>
<a name="513"><span class="lineNum">     513 </span>            :         bsoncxx::v_noabi::document::value doc_value =</a>
<a name="514"><span class="lineNum">     514 </span><span class="lineCov">          4 :             builder &lt;&lt; &quot;showId&quot; &lt;&lt; show_id &lt;&lt; &quot;userEmail&quot; &lt;&lt; user_email &lt;&lt; bsoncxx::builder::stream::finalize;</span></a>
<a name="515"><span class="lineNum">     515 </span>            : </a>
<a name="516"><span class="lineNum">     516 </span>            :         try</a>
<a name="517"><span class="lineNum">     517 </span>            :         {</a>
<a name="518"><span class="lineNum">     518 </span>            :             bsoncxx::stdx::optional&lt;mongocxx::result::insert_one&gt; maybe_result =</a>
<a name="519"><span class="lineNum">     519 </span><span class="lineCov">          4 :                 collection.insert_one(doc_value.view());</span></a>
<a name="520"><span class="lineNum">     520 </span>            : </a>
<a name="521"><span class="lineNum">     521 </span><span class="lineCov">          2 :             if (maybe_result)</span></a>
<a name="522"><span class="lineNum">     522 </span>            :             {</a>
<a name="523"><span class="lineNum">     523 </span><span class="lineCov">          4 :                 std::string created_booking_id = maybe_result-&gt;inserted_id().get_oid().value.to_string();</span></a>
<a name="524"><span class="lineNum">     524 </span><span class="lineCov">          2 :                 if (created_booking_id.size() != 0)</span></a>
<a name="525"><span class="lineNum">     525 </span>            :                 {</a>
<a name="526"><span class="lineNum">     526 </span><span class="lineCov">          2 :                     return created_booking_id;</span></a>
<a name="527"><span class="lineNum">     527 </span>            :                 }</a>
<a name="528"><span class="lineNum">     528 </span>            :                 else</a>
<a name="529"><span class="lineNum">     529 </span>            :                 {</a>
<a name="530"><span class="lineNum">     530 </span><span class="lineNoCov">          0 :                     return &quot;&quot;;</span></a>
<a name="531"><span class="lineNum">     531 </span>            :                 }</a>
<a name="532"><span class="lineNum">     532 </span>            :             }</a>
<a name="533"><span class="lineNum">     533 </span>            :         }</a>
<a name="534"><span class="lineNum">     534 </span><span class="lineNoCov">          0 :         catch (const std::exception &amp;e)</span></a>
<a name="535"><span class="lineNum">     535 </span>            :         {</a>
<a name="536"><span class="lineNum">     536 </span><span class="lineNoCov">          0 :             LOGERROR(</span></a>
<a name="537"><span class="lineNum">     537 </span>            :                 &quot; error during booking creation &quot;</a>
<a name="538"><span class="lineNum">     538 </span>            :                 &lt;&lt; e.what());</a>
<a name="539"><span class="lineNum">     539 </span><span class="lineNoCov">          0 :             return &quot;&quot;;</span></a>
<a name="540"><span class="lineNum">     540 </span>            :         }</a>
<a name="541"><span class="lineNum">     541 </span><span class="lineNoCov">          0 :         return &quot;&quot;;</span></a>
<a name="542"><span class="lineNum">     542 </span>            :     }</a>
<a name="543"><span class="lineNum">     543 </span>            : } // namespace oms</a>
</pre>
      </td>
    </tr>
  </table>
  <br>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
    <tr><td class="versionInfo">Generated by: <a href="http://ltp.sourceforge.net/coverage/lcov.php" target="_parent">LCOV version 1.14</a></td></tr>
  </table>
  <br>

</body>
</html>
